import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map.Entry;
import java.util.Set;

public class DualGraphs{
	//a0 vertices
	//a1 edges
	//a2 countries
	//X4 a1 = a0 + a2 - X; X <= 2 ;a2 = 1 ... a1 - a0 + 2; a0 = a1 - a2 + X; a0 = 1 .. a1 - a2 + 2max(a0) = a1 + 1; max(a2) = a1 + 1
	int a1, X, Y;
	boolean ignorePatterns = false;
	HashMap<String, Integer> foundVectors = new HashMap<String, Integer>();
	HashMap<String, Integer> testedVectors = new HashMap<String, Integer>();
	HashMap<String, String> ignoredVectors = new HashMap<String, String>();
	ArrayList<int[][]>  allB10;
	private void doTheTango(int a1, int X, int Y, boolean ignorePatterns){
		this.a1 = a1;
		this.X = X;
		this.Y = Y;
		this.ignorePatterns = ignorePatterns;
		//generate all matrices (use rules to eliminate forbidden in generation process
		//X4, covering also X0: A0 + A2 - A1 = 1
		for(int a0 = 1; a0 <= (a1 / 2) + 1; a0++){
			//generate all B10 (organized)
			generateAllB10Matrices(a0, a1);
			for(int a2 = a0; a2 <= a1 - a0 + 2; a2++){
				System.out.println("A2_0:" + a2);
				if(((a0 + a2 - a1) > X)&&((a0 + a2 - a1) <= Y)){//exclude X bigger than
					//dimensionate matrix:
					int B10[][] = new int[a1][a0];
					int B12[][] = new int[a1][a2];
					for(int i = 0; i < allB10.size(); i++){
						B10 = allB10.get(i);
						if(testConnect(B10)){//test connectedness before going into generating all right side matrix
							//calculate the bivector
							//if the bivector is not in foundVectors
							//test connectedness
							//if conn then calculate save bivector to foundVectors
							generateAndAnalizeB12ForB10(B10, a2);
						}
					}
				}
			}
		}
		//generate all possible vectors and search if present in foundVectors if vector NOT present in foudVectors, print SOMETHING
		System.out.println("SEARCHING FINAL VECTORS, number of found vectors: "+this.foundVectors.size());
		testVectors();
		//print statistics
		for (String key: foundVectors.keySet()) {
	    System.out.println(key);
		}
		System.out.println("********************************************************");
		for (Entry<String, String> key: ignoredVectors.entrySet()) {
	    System.out.println(key.getKey() + " " + key.getValue());
		}
	}


	private void generateAndAnalizeB12ForB10(int[][] b10, int a2) {
		//this part can be saved - in a structure for all a1
		int numberOfVectors = (int)Math.pow(3, b10.length);
		ArrayList<int[]> goodVectors = new ArrayList<int[]>();
		for(int i = 1; i < numberOfVectors; i++){
			//generate all vectors
			int tmpVector[] = new int[b10.length];
			//zeroes are in vector by definition
			int counter = 0, tmpI = i;
			while (tmpI > 0){
				tmpVector[counter++] = tmpI % 3;
				tmpI = tmpI / 3;
			}
			//check if
			boolean checker = true;
			for (int j = 0; j < b10[0].length; j++) {
				int tmp = 0;
				for (int k = 0; k < b10.length; k++) {
					tmp += b10[k][j] * tmpVector[k];
				}
				if(tmp % 2 != 0){ 
					checker = false;
					break;
				}
			}
			if(checker){
				goodVectors.add(tmpVector);
			}
		}
		int lines[][] = new int[goodVectors.size()][a1];
		for(int i = 0; i < goodVectors.size(); i++){
			int tmp[] = goodVectors.get(i);
			for (int j = 0; j < tmp.length; j++) {
				lines[i][j] = tmp[j];
			}
		}
		genAllB12Tmp(-1, a2, a1, null, lines, b10);
	}
	
	private void genAllB12Tmp(int i, int a2, int a1, ArrayList<int[]> tmpMatrix, int[][] lines, int b10[][]) {
		ArrayList<int[]> newTmpMatrix;
		boolean goOn = true;
		if(i < 0){
			newTmpMatrix = new ArrayList<int[]>();
			i = 0;
		}
		else{ 
			newTmpMatrix = new ArrayList<int[]>(tmpMatrix);	
			int[] line = new int[lines[i].length];
			int[] tmpSum = new int[lines[i].length];
			for(int z = 0; z < lines[i].length; z++){
				line[z] = lines[i][z];
			}
			//check if sum in every line (we will transpose at the end) is at max 2
			for(int z = 0; z < newTmpMatrix.size(); z++){
				int tmpLine[] = newTmpMatrix.get(z);
				for(int w = 0; w < lines[i].length; w++){
					tmpSum[w] += tmpLine[w]; 
				}
			}
			int tmpAllSum = 0;
			for(int z = 0; z < lines[i].length; z++){
				tmpAllSum += tmpSum[z] + line[z];
				/*if(tmpAllSum > 2 * a1){
					goOn = false;
					break;
				}*/
				if(tmpSum[z] + line[z] > 2){
					goOn = false;
					break;
				}
			}
			newTmpMatrix.add(line);
		}
		if(goOn){
			if(newTmpMatrix.size() == a2){
				int tmpB12[][] = new int[a1][a2];
				int tmpSum = 0; 
				//transpose the matrix
				for(int j = 0; j < newTmpMatrix.size(); j++) {
					int tmp[] = newTmpMatrix.get(j);
					for (int k = 0; k < tmpB12.length; k++) {
						tmpB12[k][j] = tmp[k];
						tmpSum += tmp[k];
					}
				}
				//test if both sides' sums are exactly 2a1 i.e. test only B12 matrix, B10 have all been tested
				if(tmpSum == 2 * a1){
					MyVector finalVector = generateVector(b10, tmpB12);
					MyVector finalVector1 = generateVector(tmpB12, b10);
					//test if vector already in found
					boolean stopTest;
					if(ignorePatterns){
						stopTest = this.excludePatterns(finalVector);
						if(!stopTest) stopTest = this.excludePatterns(finalVector1);
					}
					else{
						stopTest = false;
					}
					if(!stopTest && (foundVectors.get(finalVector.str) == null)){
						//test connectedness
						boolean good = true;
						if(!testConnect(b10)){
							good = false;
						}
						else if(!testConnect(tmpB12)){
							good = false;
						}
						else{
							//generate local graphs
							//test local connectedness
							if(generateLocalGraphsTestForConnect(b10, tmpB12)){
								if(generateLocalGraphsTestForConnect(tmpB12, b10)){
									good = true;
								}
								else{
									good = false;
								}
							}
							else{
								good = false;
							}
						}
						if(good){
							foundVectors.put(finalVector.str, 1);
							foundVectors.put(finalVector1.str, 1);
						}
					}
				}
			}
			else{
				for(int x = i; x < lines.length; x++){
					genAllB12Tmp(x, a2, a1, newTmpMatrix, lines, b10);
				}
			}
		}
	}
	
	private boolean generateLocalGraphsTestForConnect(int[][] b10, int[][] tmpB12) {
		ArrayList<int[]> tmpMatrix, tmpMatrix2;
		boolean finalResult = true;
		for (int i = 0; i < b10[0].length; i++) {
			tmpMatrix = new ArrayList<int[]>();
			//copy and transpose
			int counter = 0;
			for (int j = 0; j < tmpB12.length; j++) {
				if(b10[j][i] > 0) counter++;
			}
			for(int j = 0; j < tmpB12[0].length; j++) {
				int tmp[] = new int[counter];
				int newCounter = 0;
				for (int k = 0; k < tmpB12.length; k++) {
					if(b10[k][i] > 0){//dimensions are not same, but counted 0 values in previous loop 
						tmp[newCounter++] = tmpB12[k][j];
					}
				}
				tmpMatrix.add(tmp);
			}
			boolean deletions[] = new boolean[tmpMatrix.size()];
			for (int j = 0; j < tmpMatrix.size(); j++) {
				int tmp[] = tmpMatrix.get(j);
				int sum = 0;
				for (int j2 = 0; j2 < tmp.length; j2++) {
					sum += tmp[j2];
				}
				if(sum == 0){
					deletions[j] = true;
				}
			}
			for (int j = deletions.length - 1; j >= 0; j--) {
				if(deletions[j]){
					tmpMatrix.remove(j);
				}
			}
			//transpose again
			int[][] tmptmp = new int[tmpMatrix.get(0).length][tmpMatrix.size()];
			for (int j2 = 0; j2 < tmpMatrix.size(); j2++) {
				for (int j3 = 0; j3 < tmpMatrix.get(j2).length; j3++) {
					tmptmp[j3][j2] = tmpMatrix.get(j2)[j3];
				}
			}
			//test connect
			if(!testConnect(tmptmp)){
				return(false);
			}
		}
		return true;
	}

	private boolean testConnect(ArrayList<int[]> graph){
		int rez[][] = new int[graph.size()][graph.get(0).length];
		for(int i = 0; i < rez.length; i++){
			int tmp[] = graph.get(i);
			for (int j = 0; j < tmp.length; j++) {
				rez[i][j] = tmp[j];
			}
		}
		return(testConnect(rez));
	}
	
	private boolean testConnect(int[][] graph){
		//make adjacency list
		ArrayList<Set<Integer>> listGraph = new ArrayList<Set<Integer>>();
		for (int i = 0; i < graph[0].length; i++) {
			listGraph.add(new HashSet<Integer>());
		}
		for (int i = 0; i < graph.length; i++) {
			int n1 = -1, n2 = -1;
			for (int j = 0; j < graph[i].length; j++) {
				if(graph[i][j] == 1){
					if(n1 < 0) n1 = j;
					else n2 = j;
				}
			}
			if(n1 >= 0 && n2 >= 0){
				listGraph.get(n1).add(n2);
				listGraph.get(n2).add(n1);
			}
		}
		boolean visited[] = new boolean[graph[0].length];
		LinkedList<Integer> queue = new LinkedList<Integer>();
		//BFS
		queue.addLast(0);
		visited[0] = true;

		while(queue.size() > 0){
			int tmp = queue.poll();
	    for (Iterator<Integer> iterator = listGraph.get(tmp).iterator(); iterator.hasNext();) {
	       Integer tmp2 = iterator.next();
	       if (!visited[tmp2]) {
	          queue.addLast(tmp2);
	          visited[tmp2] = true;
	       }
	    }
	 }
		boolean connected = true;
		for (int i = 0; i < visited.length; i++) {
			if(!visited[i]){
				connected = false;
				break;
			}
		}
		return(connected);
	}
	
	private MyVector generateVector(int[][] b10, int[][] b12) {
		int tmpInt1[] = new int[b10[0].length];
		int tmpInt2[] = new int[b12[0].length];
		for (int i = 0; i < b10[0].length; i++) {
			for (int j = 0; j < b10.length; j++) {
				tmpInt1[i] += b10[j][i];
			}
		}
		for (int i = 0; i < b12[0].length; i++) {
			for (int j = 0; j < b12.length; j++) {
				tmpInt2[i] += b12[j][i];
			}
		}
		Arrays.sort(tmpInt1);
		Arrays.sort(tmpInt2);
		String rez = "";
		for (int j = 0; j < tmpInt1.length; j++) {
			rez +=  String.format("%2d", tmpInt1[j]);;
		}
		rez += ":";
		for (int j = 0; j < tmpInt2.length; j++) {
			rez +=  String.format("%2d", tmpInt2[j]);;
		} 
		return new MyVector(rez, tmpInt1, tmpInt2);
	}

	private void generateAllB10Matrices(int a0, int a1) {
		this.allB10 = new ArrayList<int[][]>();
		int nrLines = a0 + (a0*(a0 - 1))/2;
		int lines[][] = new int[nrLines][a0];
		int counter = 0;
		for(int i = 0; i < a0; i++) {
			lines[counter++][i] = 2;
		}
		for(int i = 0; i < a0 - 1; i++) {
			for(int j = i + 1; j < a0; j++) {
				lines[counter][i] = 1;
				lines[counter][j] = 1;
				counter++;
			}
		}
		genAllB10Tmp(-1, a0, a1, null, lines);
	}

	private void genAllB10Tmp(int i, int a0, int a1, ArrayList<int[]> tmpMatrix, int[][] lines) {
		ArrayList<int[]> newTmpMatrix;
		if(i < 0){
			newTmpMatrix = new ArrayList<int[]>();
			i = 0;
		}
		else{ 
			newTmpMatrix = new ArrayList<int[]>(tmpMatrix);	
			int[] line = new int[lines[i].length];
			for(int z = 0; z < lines[i].length; z++){
				line[z] = lines[i][z];
			}
			newTmpMatrix.add(line);
		}
		if(newTmpMatrix.size() == a1){
			int tmptmp[][] = new int[a1][a0];
			int tmpSum = 0;
			for(int j = 0; j < newTmpMatrix.size(); j++) {
				tmptmp[j] = newTmpMatrix.get(j);
				for(int k = 0; k < a0; k++) {
					tmpSum += tmptmp[j][k]; 
				}
			}
			//test if sum of all elements is 2*a1
			if(tmpSum == 2 * a1){
				//add result to the list of all B10
				allB10.add(tmptmp);
			}
		}
		else{
			for(int x = i; x < lines.length; x++){
				genAllB10Tmp(x, a0, a1, newTmpMatrix, lines);
			}
		}
	}

	private void testVectors(){
		//generate all possible bi-vectors, sum of all elements in each vector is a1*2, value of each element in vector is at most a1 * 2 
		for(int a0 = 1; a0 <= a1 + 1; a0++){
			for(int a2 = 1; a2 <= a1 - a0 + 2; a2++){
				if(((a0 + a2 - a1) > X)&&((a0 + a2 - a1) <= Y)){//exclude 
					ArrayList<Integer> numbers = new ArrayList<Integer>();
					for(int i = 1; i <= a1 * 2; i++){
						numbers.add(i);
					}
					ArrayList<Integer> curr = new ArrayList<Integer>();
					possibleStrings(a0, a1, a2, 0, numbers, curr);
				}
			}
		}
	}

	public void possibleStrings(int a0, int a1, int a2, int counter, ArrayList<Integer> alphabet, ArrayList<Integer> curr) {
		if(curr.size() == a0){
			ArrayList<Integer> curr1 = new ArrayList<Integer>();
			int sum = 0;
			for(int i = 0; i < curr.size(); i++) {
				sum += curr.get(i);
			}
			if(sum == a1 * 2) possibleStrings1(a0, a1, a2, 0, alphabet, curr1, curr);
		}else {
			int sum = 0;
	    for(int i = counter; i < alphabet.size(); i++) {
	    	ArrayList<Integer> oldCurr = new ArrayList<Integer>(curr);
	    	if((sum + alphabet.get(i)) <= (a1 * 2)){
		      curr.add(alphabet.get(i));
		      possibleStrings(a0, a1, a2, i, alphabet, curr);
		      curr = oldCurr;
	    	}
	    }
		}
	}
	
	public void possibleStrings1(int a0, int a1, int a2, int counter, ArrayList<Integer> alphabet, ArrayList<Integer> curr, ArrayList<Integer> firstVector) {
		if(curr.size() == a2){
			int sum = 0;
			for(int i = 0; i < curr.size(); i++) {
				sum += curr.get(i);
			}
			if(sum == a1 * 2){
				//generate vector
				int tmpB10[] = new int[firstVector.size()], tmpB12[] = new int[curr.size()];
				for(int i = 0; i < firstVector.size(); i++) {
					tmpB10[i] = firstVector.get(i);
				}
				for(int i = 0; i < curr.size(); i++) {
					tmpB12[i] = curr.get(i);
				}
				String finalVector = "", finalVector1 = "";
				for(int i = 0; i < firstVector.size(); i++){
					finalVector += String.format("%2d", firstVector.get(i));
				}
				for(int i = 0; i < curr.size(); i++){
					finalVector1 += String.format("%2d", curr.get(i));
				}
				MyVector mv1 = new MyVector("", tmpB10, tmpB12);
				MyVector mv2 = new MyVector("", tmpB12, tmpB10);
				//lookup in the hashmap of all vectors
				boolean stopTest = false;
				if(ignorePatterns){
					if((this.ignoredVectors.get(finalVector+":"+finalVector1) != null)||(this.ignoredVectors.get(finalVector1+":"+finalVector) != null)){
						stopTest = true;
					}
					else{
						stopTest = false;
					}
				}
				if(stopTest){
					System.out.println("IGNORED:" + finalVector+":"+finalVector1 + " Chi=" + (a0 + a2 - a1));
				}else if((testedVectors.get(finalVector+":"+finalVector1) == null) && (testedVectors.get(finalVector+":"+finalVector1) == null)){
					testedVectors.put(finalVector+":"+finalVector1, 1);
					testedVectors.put(finalVector1+":"+finalVector, 1);
					if(this.foundVectors.get(finalVector+":"+finalVector1) != null){
						System.out.println("TRUE:" + finalVector+":"+finalVector1 + " Chi=" + (a0 + a2 - a1));
					}
					else{
						System.out.println("FALSE:" + finalVector+":"+finalVector1 + " Chi=" + (a0 + a2 - a1));
					}
				}
			}
		}else {
			int sum = 0;
	    for(int i = counter; i < alphabet.size(); i++) {
	    	ArrayList<Integer> oldCurr = new ArrayList<Integer>(curr);
	    	if((sum + alphabet.get(i)) <= (a1 * 2)){
		      curr.add(alphabet.get(i));
		      possibleStrings1(a0, a1, a2, i, alphabet, curr, firstVector);
		      curr = oldCurr;
	    	}
	    }
		}
	}
	
	boolean excludePatterns(MyVector finalVector){
		String error = "NONE";
		boolean ret = false;
		boolean tmpRet = false;
		if(finalVector.str.equals(" 4 4: 2 3 3")){
			int a = 9;
			
			int b = 9;
		}
		//chi only 2 a0 + a2 - a1
		if((finalVector.b10.length + finalVector.b12.length - this.a1) != 2){
			return(false);
		}
		if(ignoredVectors.get(finalVector.str) != null){
			return(true);
		}
		if(finalVector.b10.length == 2){//a,b:2^k
			tmpRet = true;
			error = "a,b:2^k";
			for (int i = 0; i < finalVector.b12.length; i++) {
				if(finalVector.b12[i] != 2){
					tmpRet = false;
					break;
				}
			}
		}
		ret = tmpRet;
		if(!ret){
			if(finalVector.b10.length == 2 && (finalVector.b10[0] == finalVector.b10[1])){//2^(k-2)3
				error = "2^(k-2)3";
				if(finalVector.b12[0] == 1 && finalVector.b12[0] == 3 && finalVector.b12.length == finalVector.b10[0]){
					tmpRet = true;
					for (int i = 1; i < finalVector.b12.length - 1; i++) {
						if(finalVector.b12[i] != 2){
							tmpRet = false; 
							break;
						}
					}
				}
			}
			ret = tmpRet;
		}
		if(!ret){//1^(b+1)x
			int a = finalVector.b10.length;
			if(finalVector.b10.length > 1){
				error = "1^(b+1)x";
				tmpRet = true;
				for (int i = 1; i < finalVector.b10.length; i++) {
					if(finalVector.b10[i] % 2 != 0){
						tmpRet = false;
						break;
					}
				}
				if(tmpRet){
					if(finalVector.b12[finalVector.b12.length -1] == a + a + finalVector.b12.length -1 - 2){
						for (int i = 0; i < finalVector.b12.length - 1; i++) {
							if(finalVector.b12[i] != 1){
								tmpRet = false;
								break;
							}
						}
					}else{
						tmpRet = false;
					}
				}
			}
			ret = tmpRet;
		}
		if(!ret){//2^(a)4
			if((finalVector.b10.length > 1)&&(finalVector.b10[finalVector.b10.length - 1] == 4)&&(finalVector.b12.length == 3)){
				error = "2^(a)4";
				tmpRet = true;
				for (int i = 1; i < finalVector.b10.length - 1; i++) {
					if(finalVector.b10[i] != 2){
						tmpRet = false; 
						break;
					}
				}
				if(tmpRet){
					if(finalVector.b12[2] != (2*(finalVector.b10.length - 1) + 4 - (finalVector.b12[0] + finalVector.b12[1]))){
						tmpRet = false;
					}
				}
			}
			ret = tmpRet;
		}
		if(!ret){//2^(a)6
			if((finalVector.b10.length > 1)&&(finalVector.b10[finalVector.b10.length - 1] == 6)&&(finalVector.b12.length == 4)){
				error = "2^(a)6";
				tmpRet = true;
				for (int i = 1; i < finalVector.b10.length - 1; i++) {
					if(finalVector.b10[i] != 2){
						tmpRet = false; 
						break;
					}
				}
			}
			ret = tmpRet;
		}
		if(!ret){//2^(a)44
			if(finalVector.b10.length > 1){
				if((finalVector.b10[finalVector.b10.length - 1] == 4) && (finalVector.b10[finalVector.b10.length - 2] == 4)&&(finalVector.b12.length == 4)){
					error = "2^(a)44";
					tmpRet = true;
					for (int i = 1; i < finalVector.b10.length - 2; i++) {
						if(finalVector.b10[i] != 2){
							tmpRet = false; 
							break;
						}
					}
				}
			}
			ret = tmpRet;
		}
		if(!ret){//2^(a)33
			if(finalVector.b10.length > 1){
				if((finalVector.b10[finalVector.b10.length - 1] == 3) && (finalVector.b10[finalVector.b10.length - 2] == 3)&&(finalVector.b12.length == 3)){
					error = "2^(a)33";
					tmpRet = true;
					for (int i = 1; i < finalVector.b10.length - 2; i++) {
						if(finalVector.b10[i] != 2){
							tmpRet = false; 
							break;
						}
					}
				}
				if(tmpRet){
					if(finalVector.b12[2] != (2*(finalVector.b10.length - 2) + 6 - (finalVector.b12[0] + finalVector.b12[1]))){
						tmpRet = false;
					}
				}
			}
			ret = tmpRet;
		}
		if(ret) ignoredVectors.put(finalVector.str, error);
		return ret;
	}
	
	public static void main(String a[]){
		DualGraphs dd = new DualGraphs();
		if(a.length == 1){
			int intTmp = Integer.parseInt(a[0]);
			if(intTmp > 0){
				dd.doTheTango(intTmp, -1000, 1000, false); //X cannot be 10, dirty hack
			}
		}
		else if(a.length == 2){
			int intTmp = Integer.parseInt(a[0]);
			int intTmp1 = Integer.parseInt(a[1]);
			if(intTmp > 0){
				dd.doTheTango(intTmp, -1000, intTmp1, false);
			}
		}
		else if(a.length == 3){
			int intTmp = Integer.parseInt(a[0]);
			int intTmp1 = Integer.parseInt(a[1]);
			int intTmp2 = Integer.parseInt(a[2]);
			if(intTmp > 0){
				dd.doTheTango(intTmp, intTmp1, intTmp2, false);
			}
		}
		else if(a.length == 4){
			int intTmp = Integer.parseInt(a[0]);
			int intTmp1 = Integer.parseInt(a[1]);
			int intTmp2 = Integer.parseInt(a[2]);
			if(intTmp > 0){
				dd.doTheTango(intTmp, intTmp1, intTmp2, true);
			}
		}
		else{
			System.out.println("Usage: java DualGraphs number_of_edges min_chi max_chi ignorePatterns");
		}
	}
	class MyVector{
		MyVector(String s, int b1[], int b2[]){
			str = s;
			b10 = b1;
			b12 = b2;
		}
		String str;
		int b10[], b12[];
	}
}